#include "amxxmodule.h"
#include "megahal.h"
#include <string.h>

//native MH_Learn(const szText[])
static cell AMX_NATIVE_CALL MH_Learn(AMX *amx, cell *params)
{
	char input[192];
	int len;

	strcpy(input, MF_GetAmxString(amx, params[1], 0, &len));

	//OK: no micro stutter at this moment. It just learned the chat.
	megahal_learn_no_reply(input, 0);
	
	return 1;
}

//native MH_Reply(const szText[])
static cell AMX_NATIVE_CALL MH_Reply(AMX *amx, cell *params)
{
	char input[192];
	int len;

	strcpy(input, MF_GetAmxString(amx, params[1], 0, &len));
	
	//Bad.. bad..: micro stutter about 0.2~0.3 second every reply function called.
	megahal_do_reply(input, 0);
	
	//Help.. help: How to parse replied output and add it into amxx?
	
	return 1;
}

AMX_NATIVE_INFO fun_Exports[] =
{
	{"MH_Learn",		MH_Learn},
	{"MH_Reply",		MH_Reply},
	{NULL,					NULL}
};

void OnAmxxAttach()
{
	MF_AddNatives(fun_Exports);
}

void OnPluginsLoaded()
{
	megahal_initialize();
}

void OnPluginsUnloaded()
{
	//Save all bot personality and dictionary
	megahal_cleanup();
}
